#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	xorg-server
Version		:	21.1.11
Release		:	16.2.0.rel%{?dist}
Summary		:	X.Org X11 X server
Group		:	User Interface/X

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://cgit.freedesktop.org/xorg/xserver/
			#https://xorg.freedesktop.org/releases/individual/xserver/

Source0		:	%{name}-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	elogind-devel
BuildRequires	:	eudev-devel
BuildRequires	:	font-util
BuildRequires	:	libdrm
BuildRequires	:	libepoxy
BuildRequires	:	libunwind-devel
BuildRequires	:	libxcvt-devel
BuildRequires	:	libXdmcp
BuildRequires	:	pixman
BuildRequires	:	wayland-protocols
BuildRequires	:	xcb-util-image
BuildRequires	:	xcb-util-keysyms
BuildRequires	:	xcb-util-renderutil
BuildRequires	:	xcb-util-wm
BuildRequires	:	xkbcomp
BuildRequires	:	xkeyboard-config
BuildRequires	:	xorg-libGL
BuildRequires	:	xorg-libX11
BuildRequires	:	xorg-libXfont2
BuildRequires	:	xorg-libxkbfile
BuildRequires	:	xorg-xtrans

#-----------------------------------------------------------------------------
Requires	:	xorg-x11-fonts-misc
Requires	:	xkeyboard-config
Requires	:	xkbcomp
Requires	:	xhost
Requires	:	wayland
Requires	:	libinput
#-----------------------------------------------------------------------------
%description
The X server accepts requests from client applications to create windows,
which are (normally rectangular) "virtual screens" that the client program
can draw into.

Windows are then composed on the actual screen by the X server
(or by a separate composite manager) as directed by the window manager,
which usually communicates with the user via graphical controls such as buttons
and draggable titlebars and borders.

For a comprehensive overview of X Server and X Window System, consult the
following article:
https://en.wikipedia.org/wiki/X_server

#-----------------------------------------------------------------------------
%files			
%defattr(-, root,root,-)
%doc COPYING README.md
%dir %{_sysconfdir}/X11/xorg.conf.d
%{_includedir}/xorg/*.h
%{_bindir}/X
%{_bindir}/Xnest
%{_bindir}/Xorg
%{_bindir}/Xvfb
%{_bindir}/Xephyr
%{_bindir}/gtf
%{_libexecdir}/Xorg
%{_libexecdir}/Xorg.wrap
%{_libdir}/xorg/modules/drivers/*.so
%{_libdir}/xorg/modules/extensions/*.so
%{_libdir}/xorg/modules/input/inputtest_drv.so
%{_libdir}/xorg/modules/*.so
%{_libdir}/xorg/protocol.txt
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/aclocal/%{name}.m4
%{_datadir}/X11/xorg.conf.d/10-quirks.conf
%{_mandir}/man1/*.1.gz
%{_mandir}/man4/*.4.gz
%{_mandir}/man5/*.5.gz

#=============================================================================
%prep
%setup -q
#Fix an issue with gcc-12 and later: 
sed -i								\
  -e '/(SourcePictPtr)/s/sizeof([^)]*)/sizeof(SourcePict)/'	\
  render/picture.c

#-----------------------------------------------------------------------------
#building application
%build

meson							\
	$XORG_CONFIG					\
        --includedir=%{_includedir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	-D ipv6=true					\
	-D xvfb=true					\
	-D xnest=true 					\
	-D xcsecurity=true				\
	-D xorg=true 					\
	-D xephyr=true					\
	-D glamor=true					\
	-D udev=true					\
	-D dtrace=false					\
	-D systemd_logind=false				\
	-D suid_wrapper=true				\
	-D xinerama=true				\
	-D xkb_dir=%{_datadir}/X11/xkb			\
	-D xkb_output_dir=%{_var}/lib/xkb		\
	_build

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
ninja 							\
	-C _build					\
	%{_smp_mflags}


#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	ninja						\
	-C _build					\
	install


%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/X11/xorg.conf.d

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
